//+------------------------------------------------------------------+
//|                                           ZigXPips Close_nmc.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_width1 1
//
extern double ReversalPercent=0.3;
extern bool UseReversalPips=true;
extern bool ShowBarsCount=false;
extern int ReversalPips=200;
extern bool ShowPipsValue=true;
extern bool HidePippets=false;
extern int FontSize=8;
extern string FontName="Arial";
extern color FontColor=Yellow;
extern int TextIndentUp=50;
extern int TextIndentDown=50;
extern int LinesWidth=0;

double zz[],zzUp[],zzDn[];
int    last, prevLast, nBarsInZ,counted_bars=IndicatorCounted();
   double reverse, prev, dPipsValue;
   bool bUp=true;
   //int ;
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,zz);  SetIndexStyle(0,DRAW_SECTION);//SetIndexStyle(0,DRAW_LINE,0,2);//SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(1,zzUp);SetIndexStyle(1,DRAW_ARROW,0,LinesWidth);SetIndexArrow(1,110);
   SetIndexBuffer(2,zzDn);SetIndexStyle(2,DRAW_ARROW,0,LinesWidth);SetIndexArrow(2,110);   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_TEXT);
//----
   return(0);
  }  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (
                 const int rates_total,      // size of input time series
                 const int prev_calculated,  // bars handled in previous call
                 const datetime& time[],     // Time
                 const double& open[],       // Open
                 const double& high[],       // High
                 const double& low[],        // Low
                 const double& close[],      // close
                 const long& tick_volume[],  // Tick Volume
                 const long& volume[],       // Real Volume
                 const int& spread[]         // Spread
                )

  {
//---
 string sData, id;
//int    nBarsInZ,counted_bars=IndicatorCounted();
int  limit  = MathMin(rates_total,rates_total-1);
    reverse = ReversalPips*Point;   
    for(int i=limit; i>=0&& !IsStopped(); i--)
    {
      if (UseReversalPips) reverse=ReversalPips*Point;
      else reverse = NormalizeDouble(ReversalPercent*Close[i]/100,Digits);
      if (bUp)
         {
          //if (High[i]>prev)
          if (Close[i]>prev)
            {
            //zz[i]=High[i];
            zz[i]=Close[i]; 
            //prev=High[i];
            prev=Close[i];
            //zzUp[i]=High[i];
            zzUp[i]=Close[i];
            zz[last]=EMPTY_VALUE; 
            //zzUp[last]=EMPTY_VALUE;
            ChartRedraw(0);
            last=i; 
            }
         else
            {
            //if (Low[i]<prev-reverse)
            if (Close[i]<prev-reverse)
               {
               bUp=false;
               //zz[i]=Low[i]; 
               zz[i]=Close[i];
               //prev=Low[i];
               prev=Close[i];
               //zzDn[i]=Low[i];
               zzDn[i]=Close[i];
               //zzUp[i]=Low[i];
               if (ShowPipsValue)
                  {
                  //dPipsValue=(High[last]-Low[prevLast])/Point; //     
                  dPipsValue=(Close[last]-Close[prevLast])/Point;
                  nBarsInZ=prevLast-last; // -   
                  if (HidePippets==true) sData=DoubleToStr(dPipsValue/10,0); else sData=DoubleToStr(dPipsValue,0);
                  if (ShowBarsCount==true) sData=StringConcatenate(sData," (",nBarsInZ,")");
                  id="exm"+DoubleToStr(prevLast);
                  //     
                  if (ObjectFind(id)==-1)
                     {
                      //ObjectCreate(id,OBJ_TEXT,0,Time[last],High[last]+(TextIndentUp)*Point);
                       ObjectCreate(id,OBJ_TEXT,0,Time[last],Close[last]+(TextIndentUp)*Point);
                     //ObjectSetText(id,sData,FontSize,FontName,FontColor);
                     }
                  //ObjectMove(id,0,Time[last],High[last]+(TextIndentUp)*Point);
                  ObjectMove(id,0,Time[last],Close[last]+(TextIndentUp)*Point);
                  ObjectSetText(id,sData,FontSize,FontName,FontColor);
                  //zzUp[last]=High[last];
                  zzUp[last]=Close[last];
                  }
               prevLast=last;ChartRedraw(0); last=i;
               }
                else
               {
               zz[i]=EMPTY_VALUE;
               //zzDn[i]=EMPTY_VALUE;
               //zzUp[i]=EMPTY_VALUE;
               }
            }
         }
               else
         {
         //   
         //if (Low[i]<prev)
         if (Close[i]<prev)
            {
            //zz[i]=Low[i]; 
            zz[i]=Close[i]; 
            //prev=Low[i];
            prev=Close[i];
            //zzDn[i]=Low[i];
            zzDn[i]=Close[i];
            zz[last]=EMPTY_VALUE; 
            //zzDn[last]=EMPTY_VALUE;
            ChartRedraw(0);
            last=i;
            }
         else
            {
            //   
            //if (High[i]>prev+reverse)
            if (Close[i]>prev+reverse)
               {
               bUp=true;
               //zz[i]=High[i]; 
               zz[i]=Close[i]; 
               //prev=High[i];
               prev=Close[i];
               //zzUp[i]=High[i];
               zzUp[i]=Close[i];
               //zzDn[i]=High[i];
               if (ShowPipsValue)
                  {
                  //dPipsValue=(High[prevLast]-Low[last])/Point; //     
                  dPipsValue=(Close[prevLast]-Close[last])/Point;
                      nBarsInZ = prevLast-last; // -   
                  if (HidePippets==true) sData=DoubleToStr(dPipsValue/10,0); else sData=DoubleToStr(dPipsValue,0);
                  if (ShowBarsCount==true)
                  {
                    sData=StringConcatenate(sData," (",nBarsInZ,")");
                  }  
                  id="exm"+DoubleToStr(prevLast);
                  //     
                  if (ObjectFind(id)==-1)
                     {
                     //ObjectCreate(id,OBJ_TEXT,0,Time[last],Low[last]-TextIndentDown*Point);
                       ObjectCreate(id,OBJ_TEXT,0,Time[last],Close[last]-TextIndentDown*Point);
                     //ObjectSetText(id,sData,FontSize,FontName,FontColor);
                     }
                  //ObjectMove(id,0,Time[last],Low[last]-TextIndentDown*Point);
                  ObjectMove(id,0,Time[last],Close[last]-TextIndentDown*Point);
                  ObjectSetText(id,sData,FontSize,FontName,FontColor);
                  //zzDn[last]=Low[last];
                  zzDn[last]=Close[last];
                  }
               prevLast=last;ChartRedraw(0); last=i;
               }
            //   
            else
               {
               zz[i]=EMPTY_VALUE;
               zzUp[i]=EMPTY_VALUE;
               zzDn[i]=EMPTY_VALUE;
               ChartRedraw(0);
               }
            }
         }
   }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
